clear; pack; close all; clc;
%----------------
% Unknown system:
%----------------
wo=[1 -.5 .5j -.5j].'; %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%% wo=abs([1 -.5 .5j -.5j].');
N=length(wo)-1; % filter order
% Input signal;
tam=500;
x=randn(tam,1)+j*randn(tam,1); %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% x=randn(tam,1);
x=x/std(x)-mean(x);
% Generating the reference signal:
sigman2=1e-8;
n=randn(tam,1)+j*randn(tam,1); %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% n=randn(tam,1);
n=sqrt(sigman2)*(n/std(n)-mean(n));
d=filter(conj(wo),1,x)+n;
% Assuming stationarity of the input dignal:
R       = zeros(N+1,N+1);
p       = zeros(N+1,1);
vectorx = zeros(N+1,1);
for k=1:tam
    vectorx = [x(k); vectorx(1:N)];
    R       = R + vectorx*vectorx'; 
    p       = p + conj(d(k))*vectorx;
end
R = R/tam;
p = p/tam;
wo_hat=inv(R)*p;  % (estimated) Wiener solution
pause(.5); clc;
%---------------------------------
MSEAPA   = zeros(tam,1);
MSEBNDR1 = zeros(tam,1);
MSEBNDR2 = zeros(tam,1);
MSERLS   = zeros(tam,1);
mu       = 1;
epsilon  = 1e-6;
vectorx  = zeros(N+1,1);
% Init. APA:
L        = 2;
dofk     = zeros(L,1);
Xofk     = zeros(N+1,L);
w_APA    = zeros(N+1,1);
% Init. BNDR:
vectorxant = zeros(N+1,1);
rhokant    = 0;
epostkant  = 0;
dkant=0;
w_BNDR1    = zeros(N+1,1);
w_BNDR2    = zeros(N+1,1);
% Init. RLS:
lambda     = 0.95;
w_RLS      = zeros(N+1,1);
invR       = eye(N+1);
for k=1:tam
    vectorx = [x(k); vectorx(1:N)];
    %-----------------------------
    % Affine Projection Algorithm:
    %-----------------------------
    dofk       = [d(k); dofk(1:L-1)];
    Xofk       = [vectorx Xofk(:,1:L-1)];
    eofk       = dofk-Xofk.'*conj(w_APA);
    tofk       = inv(Xofk'*Xofk+epsilon*eye(L))*conj(eofk);
    w_APA      = w_APA+mu*Xofk*tofk;
    MSEAPA(k)  = MSEAPA(k) + abs(eofk(1))^2;
    %--------------------------------
    % BNDR-LMS Algorithm (version 1):
    %--------------------------------
    eBNDR1 = d(k) - w_BNDR1'*vectorx;
    alpha  = vectorx'*vectorxant;
    rhok   = vectorx'*vectorx;
    D      = rhok*rhokant-abs(alpha)^2;
    if D < epsilon
        w_BNDR1 = w_BNDR1 + mu*conj(eBNDR1)*vectorx/rhok;
    else
        lamb1   = (conj(eBNDR1)*rhokant-conj(epostkant)*alpha)/D;
        lamb2   = (conj(epostkant)*rhok-conj(eBNDR1)*conj(alpha))/D;
        w_BNDR1 = w_BNDR1 + mu*(lamb1*vectorx+lamb2*vectorxant);
    end
    MSEBNDR1(k) = MSEBNDR1(k) + abs(eBNDR1)^2;
    epostkant   = d(k) - w_BNDR1'*vectorx;
    rhokant     = rhok;
    %--------------------------------
    % BNDR-LMS Algorithm (version 2):
    %--------------------------------
    eBNDR2      = d(k) - w_BNDR2'*vectorx;
    w1          = w_BNDR2+conj(eBNDR2)*vectorx/(vectorx'*vectorx+epsilon);
    e1          = dkant-w1'*vectorxant;
    dkant       = d(k);
    xPERP       = (eye(length(vectorx))-vectorx*vectorx'/(vectorx'*vectorx)+epsilon)*vectorxant;
    w_BNDR2     = w_BNDR2+mu*(conj(eBNDR2)*vectorx/(vectorx'*vectorx+epsilon)+conj(e1)*xPERP/(xPERP'*xPERP+epsilon));
    MSEBNDR2(k) = MSEBNDR2(k) + abs(eBNDR2)^2;
    vectorxant  = vectorx;
    %---------------
    % RLS Algorithm:
    %---------------
    eRLS = d(k) - w_RLS'*vectorx;  % a priori error
    vectork=invR*vectorx;
    kappa=vectork/(lambda+vectorx'*vectork);
    invR=(1/lambda)*(invR-kappa*vectork');
    w_RLS = w_RLS + conj(eRLS)*kappa;      
    MSERLS(k)=MSERLS(k)+abs(eRLS)^2;
end
MSEdBAPA=10*log10(MSEAPA);
MSEdBBNDR1=10*log10(MSEBNDR1);
MSEdBBNDR2=10*log10(MSEBNDR2);
MSEdBRLS=10*log10(MSERLS);
plot(MSEdBAPA)
hold
plot(MSEdBBNDR1,'o--k')
plot(MSEdBBNDR2,'--m')
plot(MSEdBRLS,'r')
legend('APA','BNDR-LMS v.1','BNDR-LMS v.2','RLS')
    






