function [W, E, invU]=InvQRD_RLS(W, invU, X, d, lambda, L)
%  +--------------------------+ 
%  |     Inverse QRD-RLS      | 
%  |        Algorithm         | 
%  |   Antonio L. L. Ramos    |
%  |       10/04/2004         | 
%  +--------------------------+ 
%----------------------------------------------------------------------
% Obtaining a(k) ... eh o z(n) dos chineses.  
a                  = lambda^(-1/2)*invU'*X;
% Obtaining Qtheta(K) ... o P(n) dos chinos
invgamma           = 1;
Qtheta             = eye(L+1,L+1);
for i=1:L
     oldfriend     = invgamma;
     invgamma      = sqrt(abs(invgamma)^2+abs(a(L-i+1))^2);
     ctheta(i-1+1) = abs(oldfriend)/invgamma;
     stheta(i-1+1) = conj((a(L-i+1)*ctheta(i-1+1))/oldfriend); 
     Qtheta        = [ctheta(i-1+1)       zeros(1,L-i)   -stheta(i-1+1)  zeros(1,i-1)
                      zeros(L-i,1)       eye(L-i)        zeros(L-i,1)  zeros(L-i,i-1)
                      conj(stheta(i-1+1)) zeros(1,L-i)    ctheta(i-1+1)  zeros(1,i-1)
                      zeros(i-1,1)        zeros(i-1,L-i)  zeros(i-1,1)   eye(i-1)]*Qtheta;
end; % do for i
gamma                 = 1/invgamma; % invgamma eh o "t(n)" dos chineses
% Obtaining u(k) and updating invU(k) ... u(k) eh o g(k)
AUX     = Qtheta*[zeros(1,L); lambda^(-1/2)*invU'];
u       = AUX(1,:)';
invU    = AUX(2:L+1,:)';
% E       =(d-W'*X)*gamma^2;
E       =d-W'*X;
% W       = W - conj(E)*u; Erro!!
W       = W - conj(E)*u*gamma;
