function [W, E, R_CG, c, g]=cg(W, c, g, R_CG, d, X, lambda, eta)
%  +-----------------------------------------+
%  | Conjugate Gradient Algorithm  04/2004   |
%  |         Antonio L. L. Ramos             |
%  |       alopesramos@yahoo.com.br          |
%  +-----------------------------------------+
% The algorithms have been implemented in a simple way
% (if I can say so...) to make them easy to understand.
% That means that, after you have mastered them, there is a
% lot of simplifications that can be achieved.
% So, feel free to modify and/or adjust them to your own experiments.
%
% It should be clear that the files are meant to be used for educational
% purposes only. No warranty for comercial use is offered and neither the publisher nor
% the authors shall be liable for any loss of any type.

% % Initializations for the GSC-CG Algorithm
%           0 << lambda =< 1;
%     (lambda - 0.5) =< eta =< lambda 
%     F       = C*inv(C'*C)*f;
%     W       = F;
%     WGSC_CG = zeros();
%     RGSC_CG  = P;
%     g       = zeros(M, 1);
%     c       = g;
%xGSC    = B'*X;
R_CG = lambda*R_CG + X*X';
E       = d-W'*X;
alfa    = eta*((c'*g)/(c'*R_CG*c+eps));
% Updating:
g_old   = g;
% g       = lambda*g-alfa*R_CG*c-X*conj(e);
g       = lambda*g-alfa*R_CG*c-X*conj(E);
%W       = P*W+F-alfa*c;
W    = W-alfa*c;
beta    = ((g-g_old)'*g )/(g_old'*g_old + eps);
c       = g + beta*c;
%E       = d-e;
%------------------------END of GSC-CG.m----------------------------------